
var restClient = new $.RestClient(serviceUrl);

var resources = {
	signIn: restClient.add('signIns', { url: 'system/sign-ins' }),
	session:null,
	users:null,
	userProfiles:null,
	contacts:null,
	contactCategories:null,
	notifications:null,
	announcements:null
//	users: restClient.add('users', { url: 'system/users' }),
//	userProfiles: restClient.add('userProfiles', { url: 'system/user-profiles' }),
//	contacts: restClient.add('contacts', { url: 'system/contacts' }),
//	contactCategories: restClient.add('contactCategories', { url: 'system/departments' }),
};

var userResouce = {};
userResouce.signIn = function(postData, onSucceed, onFailed){
	var xhr = new plus.net.XMLHttpRequest();
	xhr.onerror=function(e){
		var str="lengthComputable="+e.lengthComputable+"loaded="+e.loaded+";total="+e.total;
		console.log("onerror: "+str);
	}
	xhr.setRequestHeader("Accept","application/json");
	xhr.setRequestHeader("Content-Type","application/json");
	xhr.onreadystatechange = function () {
		switch ( xhr.readyState ) {
			case 0:
				console.log( "xhr请求已初始化" );
			break;
			case 1:
				console.log( "xhr请求已打开" );
			break;
			case 2:
				console.log( "xhr请求已发送" );
			break;
			case 3:
					console.log(xhr.responseText);
				console.log( "xhr请求已响应");
				break;
			case 4:
				if ( xhr.status == 200 ) {
					console.log(xhr.responseText);
					console.log( "xhr请求成功" );
					if(onSucceed){
						onSucceed(JSON.parse(xhr.responseText));
					}
				} else {
//					console.log(xhr.getAllResponseHeaders());
					console.log(xhr.statusText);
					console.log( "xhr请求失败："+xhr.readyState );
					if(onFailed){
						onFailed(JSON.parse(xhr.responseText));
					}
				}
				break;
			default :
				break;
		}
	}
	xhr.open( "POST", serviceUrl+"system/sign-ins" );
	console.log(JSON.stringify(postData));
	xhr.send(JSON.stringify(postData));
};
